#!/usr/bin/perl -w
$VER="2.02";
# DF Google PagePank / Alexa Traffic Rank checker @2006-2007 www.dfservice.com


$threads=5;  # number threads
#$maxurl=15;  # -1 - unlimited
$maxscripts=3;  # -1 - unlimited (Quantity of simultaneously working scripts)
$max_connections=15;  # -1 - unlimited  (Alexa+PR*GoogleDatacenters)

$timeout=10*60; #secs

$SCRIPT="chkrpra.cgi";
$form_method="POST";  # for SSI include need GET

$GPR_CHECKER=1;
$ATR_CHECKER=1;
$GOOGLE_DATACENTERS="64.233.187.99,64.233.167.99,72.14.207.99,66.249.93.104,216.239.59.104,72.14.221.104,64.233.171.99,72.14.209.99,64.233.161.107,64.233.161.147,64.233.171.107,64.233.171.147";
$GOOGLE_TIMEOUT=5;  # sec
$ALEXA_TIMEOUT=15;  # sec
$PR_DEF_ADVCHK=1;
$PR_DEF_VALUE="max";

$ERROR_LOG="./err_chkrpra.log";

$TRIAL_VERSION=0;  # 1 - Trial, 0 - No Trial version
$INIT=1;

select(STDOUT); $| = 1; # make unbuffered 
print "Content-type: text/html\n\n<pre>";
$| = 0;

$gpr="";
$atr="";
$urls_="";
$msg="";

$chkgpr=0;
$chkatr=0;

if( !$INIT ) {
  my $cmd="./$SCRIPT";
  $cmd="./setup_$SCRIPT" if( -e("./setup_$SCRIPT") );
  $!="";
  my $ret=0;
  $ret=system("$cmd ver");
  $err=$!;
  $msg.=&errmsg($cmd, $!, $ret);
#  $msg.="<br>Err: Run $cmd - $!"  if( $! );
#	$errfile=&CheckErrorFile("$cmd");
#	$msg.="<br>Error: $errfile" if( $ret==256 || $ret<0 && ($errfile ne ""));
  if($ret>=256 && ($err eq "")) {
  	$ret=$ret/256;
	  $GPR_CHECKER=$ret&1;		
  	$ATR_CHECKER=($ret&2)?1:0;
	  $TRIAL_VERSION=($ret&4)?1:0;
		
    my $file=$ENV{'SCRIPT_FILENAME'};
    open(FILE, "+<$file" ) || print("Can't read '$file' $!");
     flock(FILE, 2);
     my @lines = <FILE>;
	   foreach $line ( @lines ) {
   		 $line =~ s/\$INIT=[0-1];/\$INIT=1;/g;
  		 $line =~ s/\$TRIAL_VERSION=[0-1]/\$TRIAL_VERSION=$TRIAL_VERSION/g;
  		 $line =~ s/\$GPR_CHECKER=[0-1]/\$GPR_CHECKER=$GPR_CHECKER/g;
  		 $line =~ s/\$ATR_CHECKER=[0-1]/\$ATR_CHECKER=$ATR_CHECKER/g;			 			 
  	 }
		 $INIT=1; 
     truncate(FILE, 0);
     seek(FILE, 0, 0);
     print FILE @lines;
    close(FILE);
	}
}
if(!$INIT) {
  print "</pre><center><font face=verdana size=2 color=red><b>$msg</b></font>";
  print "<br>Instalation error!";
  exit(0);
}

$software="DF&#153; ";
$software.="Alexa" if($ATR_CHECKER);
$software.=" / " if($GPR_CHECKER && $ATR_CHECKER);
$software.="PagePank" if($GPR_CHECKER);
$software.=" Checker v$VER";

$pradvchk=$PR_DEF_ADVCHK;
$prvalue=$PR_DEF_VALUE;

if( $ENV{'QUERY_STRING'} eq "errors" )  {  # show errors
  &view_errors;
	exit(0);
}		
		
if( ($ENV{'REQUEST_METHOD'} eq 'POST') || $ENV{'QUERY_STRING'} ) {

  &parse_GETnPOST;
  if($GPR_CHECKER && $ATR_CHECKER) {
    $chkgpr=$FORM{'gpr'}?1:0;
    $chkatr=$FORM{'atr'}?1:0;
  } else {
    if($GPR_CHECKER) {
      $chkgpr=1;
    } else {
      $chkatr=1;
    }
  }

  $ipgoogle=$pradvchk=$prvalue="";	
  $pradvchk=$FORM{'pradvchk'} if($FORM{'pradvchk'});
  $prvalue=$FORM{'prvalue'} if($FORM{'prvalue'});	
  $ipgoogle=$FORM{'ipgoogle'} if($FORM{'ipgoogle'});	
	
  if( $FORM{'url'} && ( $chkgpr || $chkatr) ) {
    if($maxscripts>0) { #       
      $curtime=time;
      for($i=0; $i<5; $i++)  {
        $run=&limit_run_script(1);
	      if($run) { last; }
    	  sleep(1);
      }
    } 
	
    my $i=0, $ret=0;
    my @url = split(/\n/, $FORM{'url'});
    my $gpron=$chkgpr?"on":"off";
    my $atron=$chkatr?"on":"off";
    # ./chkpra check gpr=on/off atr=on/off indata=file/stream infile=filename outdata=file/stream outfile=filename threads=1

		my $err_conn=0;
		my $connections=0;
    $connections++  if( $chkatr );
    if( $chkgpr ) {
		  $connections++;
			if( $prvalue && ($prvalue ne "frt") ) {
			  my @gips=split(/,/,$ipgoogle);
				$connections+=$#gips;
				if($connections>$max_connections) {
				  $#gips-=($connections-$max_connections);
					$ipgoogle=join(',', @gips);
					$err_conn=1;
				}
			}
		}
		
	
		$!="";	
	  $cmd="./$SCRIPT";	
    open(CMD, "|$cmd check gpr=$gpron atr=$atron indata=stream outdata=file outfile=$$.txt threads=$threads pradvchk=".($pradvchk?"on":"off")." prvalue=$prvalue ipgoogle=$ipgoogle gtimeout=$GOOGLE_TIMEOUT atimeout=$ALEXA_TIMEOUT") || ($msg="Error: Run ./$SCRIPT - $!"); 
     my $scon=$connections;
#		print "Error !m=$!";
     for (@url) {
       $_ =~ s/\n|\r//g;
    	 print CMD "$_\n";

			 $scon+=$connections;
       if($scon>$max_connections) { $err_conn=1;  last; }
     }
    close(CMD);
		$ret=$?;
		
		$msg="Error:  Limit of a maximum quantity of connections ($max_connections)!" if($err_conn);
		
    if($maxscripts>0) {  
      &limit_run_script(2);
    }		
  	$msg.=&errmsg($cmd, $!, $ret);		
#    $msg.="<br>Err: Run $cmd - $!"  if( $! );		
#  	$msg.="Error: Run $cmd #".($ret/256)." ($ret)!" if( int($ret/256)>0 );	
#  	$errfile=&CheckErrorFile($cmd);
#	  $msg.="<br>Error: $errfile" if( $ret==11 || $ret<0 && ($errfile ne ""));
		if( $ret==62720 || $ret==1280) {
		  $msg="Invalid server time!";
		}
		if( $ret==62976 ) {		
		  $msg="Trial period expired!";
		}
    if( $ret==256  ) {  #read key (1)
  			if(	!$TRIAL_VERSION ) {
				  &Register;
				} else {
				  system("./setup_$SCRIPT");
				}
		}

		if( $ret==65024  ) {  #error key (-2)
		   $msg="System halted! Details you can see in error log.";
		}


    open( FILE, "<./$$.txt");
    my @urls = <FILE>;
    close FILE;
    unlink("$$.txt");

#my $buffer;
#open my $oldout, ">&STDOUT";    #  STDOUT
#close STDOUT;
#open(STDOUT, '>',\$buffer);
#print "qwerty ";
#close STDOUT;
#{$buffer = "Buffer= ".$buffer;} #   $buffer
#open STDOUT, ">&", $oldout;     # STDOUT
#print STDOUT $buffer;           # $buffer  

    print qq~</pre><center>
      <table border=0 width=600 CELLPADDING=1 CELLSPACING=1 bgColor=gray align="center">
  	  <tr bgColor=#CCCCCC>
        <td><FONT color=#000000 face=verdana size=1><b>URLs</b></font></td>
    ~;
    if( $chkatr ) {
      print "<td width=12% ALIGN=\"center\"><FONT color=#000000 face=verdana size=1><b>Alexa</b></font></td>";
    }
    if( $chkgpr ) {
      print "<td width=15% ALIGN=\"center\"><FONT color=#000000 face=verdana size=1><b>Google DC</b></font></td>" if( $prvalue eq "all" );
      print "<td width=10% ALIGN=\"center\"><FONT color=#000000 face=verdana size=1><b>PageRank</b></font></td>";
    }
    print "</tr>";

    for (@urls) {
      my $gpr="N/A";
      my $atr="N/A";
      my($url,$pra1,$pra2) = split(/ /, $_);
      if( $chkgpr && $chkatr ) {
      	 $gpr=$pra1;
      	 $atr=$pra2;
      } else {
         $gpr=$atr=$pra1 if( $pra1>=0 );
      }
	 
      if( $chkgpr && $prvalue eq "all" ) {
				  $str=$gpr;
    			$gpr=int($str);					
					$str=~/\(/;
    			$prdc=$';
#				  $prdc=$`;
					chop($prdc);
					@prdcs=split(/,/,$prdc);
				  $rs="rowspan=\"".($#prdcs+2)."\"";	
	    } else {
  			  $rs="";
			}

	    $gpr="N/A" if($gpr<0);
	    $atr="N/A" if($atr<0);			
						 
      print "<tr bgColor=#ffffff><td ALIGN=\"left\" $rs>$url</td>";	 
      if( $chkatr ) {	 
        print "<td ALIGN=\"center\" $rs><FONT color=#000000 face=verdana size=1>$atr</font></td>";
      }
      if( $chkgpr ) {
        print "<td ALIGN=center><FONT color=#000000 face=verdana size=1>Average PR</font></td>" if( $prvalue eq "all" );			
        print "<td ALIGN=center><FONT color=#000000 face=verdana size=1>$gpr</font></td>";
      }
      print "</tr>";
      
			if( $chkgpr && $prvalue eq "all" ) {
  		  foreach $ippr(@prdcs) {
				  ($ip, $pr)=split(/=/,$ippr);
					$pr="N/A" if($pr<0);
          print "<tr bgColor=#ffffff><td><FONT color=#000000 face=verdana size=1>$ip</font></td>";
          print "<td ALIGN=\"center\"><FONT color=#000000 face=verdana size=1>$pr</font></td>";					
          print "</tr>";					
			  }					
      }
    }
    print "</table><center>"; 	

  } else {
    &Register if( ($ENV{'QUERY_STRING'} eq "registration") && ($ENV{'REQUEST_METHOD'} eq 'GET') );
    if( !$FORM{'reg'} ) {
      if( !$FORM{'url'} )  {  $msg="URLs for check are not found!"; }
      else {   $urls_=$FORM{'url'}; 	$urls_=~ s/\r//g; }

      if( !$chkgpr && !$chkatr ) {
        $msg="PR/Alexa is not chosen!";
      }
    } else {
      $cmd="./$SCRIPT";
      $cmd="./setup_$SCRIPT" if( -e("./setup_$SCRIPT") );
      $!="";
      if( ($ret=system("$cmd reg $FORM{'login'} $FORM{'pwd'}"))!=0 ) {
         $msg="Error registration!";
         $msg.=&errmsg($cmd, $!, $ret);
#				 $msg.="<br>Error: $cmd - $! " if($! ne "");
#         $msg.="<br>Error: Run $cmd  #".($ret/256)." ($ret)!" if( int($ret/256)>0 );
#      	 $msg.="<br>Error: ".&CheckErrorFile("$cmd") if( $ret==11 || $ret<0);
#         $errfile=&CheckErrorFile("$cmd");
#      	 $msg.="<br>Error: $errfile" if( $ret==11 || $ret<0 && ($errfile ne ""));
      }
# print "<b>Return=$m (" . ($! ? $! : "OK") . ")</b>";			
    }
  }

} else {

 if( !-e("./$SCRIPT") && -e("./setup_$SCRIPT") ) {
	 if(!$TRIAL_VERSION ) {
	   &Register;
 	 } else {
		 my $ret=0;
     $!="";		 
		 $cmd="./setup_$SCRIPT";
 	   $ret=system($cmd);
		 if($ret) {
		  print "</pre><br>Error: $cmd - $! " if($!);
	 	  print "<br><b>Instalation error #$ret! See error log '$ERROR_LOG'.</b>";
 			exit(0);
		 }
	 }
 }

}
	

print qq~
    </pre><center>
		<font face=verdana size=2 color=red><b>$msg</b></font>
    <form action="" method="$form_method">				
    <table border=0 CELLPADDING=3 CELLSPACING=1 width=600 bgColor=gray align="center">
  	  <tr>
        <td bgColor=#CCCCCC><FONT color=#000000 face=verdana size=2><B>$software
    ~;				
#    print "Check PagePank Google" if($GPR_CHECKER);
#    print " and " if($GPR_CHECKER && $ATR_CHECKER);		 
#    print "Alexa Traffic Rank" if($ATR_CHECKER);				
				
    $maxurlstr=($maxurl>0)? $maxurl : "Unlimited";				
print qq~
      </B></font></td>				
			</tr>
      <tr>
			  <td bgColor=#ffffff align="left">
         <ul><textarea rows="14" name="url" cols="60">$urls_</textarea>
				 <br>
         <FONT size="2">&nbsp;<FONT size=1>Sample: http://domain.com<br>
      </FONT>
      </td>
			</tr>
      <tr>
			  <td bgColor=#ffffff align="left">
         <ul><b>
				 <FONT size="2" face=verdana>
    ~;				
		
if($GPR_CHECKER && $ATR_CHECKER) {
  print "&nbsp;<input type=checkbox name=atr value=ON ".(!$chkatr?"":"checked")."> Check Alexa Traffic Rank<br>";
  print "&nbsp;<input type=checkbox name=gpr value=ON ".(!$chkgpr?"":"checked")."> Check Google PagePank";
}
if($GPR_CHECKER) {
$pradvchk_checked="";
$pradvchk_checked="checked" if($pradvchk);
 
$prvalue_frt=""; 
if($prvalue) { 
  $prvalue_frt="checked" if($prvalue eq "frt");
  $prvalue_max="checked" if($prvalue eq "max");
  $prvalue_min="checked" if($prvalue eq "min");
  $prvalue_avg="checked" if($prvalue eq "avg");			
  $prvalue_all="checked" if($prvalue eq "all");
} else {
  $prvalue_frt="checked";
}
 
print qq~
      </FONT>  
<br>
 <table border=0>
  <tr>
   <td>
			&nbsp; &nbsp;<input type="checkbox" value="ON" name="pradvchk" $pradvchk_checked> Advanced Check<br>
      &nbsp; &nbsp; PR Value(s):<br>
      &nbsp; &nbsp; &nbsp;<input type="radio" value="frt" name="prvalue" $prvalue_frt> First<br>
      &nbsp; &nbsp; &nbsp;<input type="radio" value="max" name="prvalue" $prvalue_max> Max<br>
      &nbsp; &nbsp; &nbsp;<input type="radio" value="min" name="prvalue" $prvalue_min> Min<br>
      &nbsp; &nbsp; &nbsp;<input type="radio" value="avg" name="prvalue" $prvalue_avg> Average<br>
      &nbsp; &nbsp; &nbsp;<input type="radio" value="all" name="prvalue" $prvalue_all> For Selected Datacenters
	 </td>
   <td valign="top" align="right">&nbsp;Google Datacenters:</td>
   <td valign="top">
       <select size="8" name="ipgoogle" multiple>
~;			 
     
     my @ips=split(/,/,$GOOGLE_DATACENTERS);
     my @sips=split(/,/,$ipgoogle);		 
	   foreach $ip( @ips ) {
		   $f=0;
		   foreach $sip( @sips ) {
			   if($sip eq $ip) {
				   $f=1;
				   last;
				 }
			 }

			 if($f) {
         $sel="selected"; 			 
			 } else {
  			 $sel="";
			 }	 
       print "<option value=\"$ip\" $sel>$ip</option>";
  	 }

print qq~				 
       </select>
		</td>
   </tr>
 </table>
~;
	 
}

print qq~  			
        </b>			
        <p align="center"><input type="submit" name="check" value="   Check   "></p>
        </td>
      </tr>
	  </table>
    </form>
    <b><a href=http://www.dfservice.com/ target=_blank style="text-decoration: none">
    <font face=Verdana size=1>$software</font></a></b>
    </center>
    ~;			

exit();


sub limit_run_script{
 my($mode) = shift;

 if($mode==1) { #start	
   $run=0;
   if ( -e "./runscripts.txt" ) { 
  	open( FILE, "+<./runscripts.txt");
  	 flock FILE, 2;
  	 @runscripts = <FILE>;
  	 if( $#runscripts>=$maxscripts ) {
		   my $f=0;
  		 for (@runscripts) {
		  	 my $scrt_time = (split(/\|/, $_))[0];
		     if( $timeout>($curtime-$scrt_time) ) {
				   $f=1;
					 last;
				 }
			 }
			 if($f) {
      	 seek (FILE, 0, 0);
			   truncate (FILE,0);
	  		 for (@runscripts) {
    		   my @scrt = split(/\|/, $_);
		       if( $timeout<=($curtime-@scrt[0]) ) {
           	 print FILE "$_";
				   }				
				 }
				 $run=1; 			
			 }
		 } else {
  		 $run=1;
	   }
  	 seek (FILE, 0, 2);		
   } else {
     $run=1;
     open( FILE, ">>./runscripts.txt");
  	  flock FILE, 2; 
   }		
   if($run) {
		 print FILE "$curtime|$$\n";
	 }
	 close FILE;
	 
	 return $run;
 }

 if($mode==2) { #end
  	open( FILE, "+<./runscripts.txt");
  	 flock FILE, 2;
  	 @runscripts = <FILE>;

   	 seek (FILE, 0, 0);
		 truncate (FILE,0);
	      for (@runscripts) {
    		   my @scrt = split(/\|/, $_);
					 chomp($scrt[1]);
		       if($$!=$scrt[1] ) {
           	 print FILE "$_";
				   }
				}
	  close FILE;
 } 
 
}

sub parse_GETnPOST {

  my( $rmhtml ) = shift;
  my( $value, $name, $buffer );
  read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  my @pairs = split(/&/, $buffer);
  for (@pairs) {
    ($name, $value) = split(/=/, $_);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/</&lt;/g if($rmhtml);
    $value =~ s/>/&gt;/g if($rmhtml);
    $FORM{$name} .= (defined $FORM{$name}) ? "," . $value : $value;
 }
 my @pairs = split(/&/, $ENV{'QUERY_STRING'});
 for (@pairs) {
    ($name, $value) = split(/=/, $_);
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} .= (defined $FORM{$name}) ? "," . $value : $value;		
#    $FORM{$name} = $value;
  }
}

sub Register {

print qq~
</pre><center>
<font face=verdana size=2 color=red><b>$msg</b></font>
<form action="" method="POST">				
<table border="0" CELLPADDING=3 CELLSPACING=1 width=325 bgColor=gray align="center">
 <tr>
	<td colspan=2 bgColor=#CCCCCC><FONT color=#000000 face=verdana size=2><B>Registration</B></font></td>				
 </tr>
 <tr bgcolor="#ffffff">
  <td align="center" colspan="2"> <font  color="#000000">Please, enter login and password of your account on <a href="http://www.dfservice.com/" target="_blank">www.dfservice.com</a></font></td>
 </tr>
 <tr bgcolor="#ffffff">
  <td bgcolor="#CCCCCC"><b>Login</b></td>
  <td><input type="text" name="login" size="12"></td>
 </tr>
 <tr bgcolor="#ffffff">
  <td bgcolor="#CCCCCC"><b>Password</b></td>
  <td><input name="pwd" type="password" size="12"></td>
 </tr>
 <tr bgcolor="#ffffff">
  <td align="center" colspan="2"><input type="submit" name=reg value="Register"></td>
 </tr>
</table>
</form>
<b><font face=Verdana size=1></font><a href=http://www.dfservice.com/ target=_blank style="text-decoration: none">
<font face=Verdana size=1>$software</font></a></b>
</center>
~;			
		
exit();
}

sub CheckErrorFile {
 my($cgifile) = shift;
 my $err="";
 # check OS
 # check binary mode

 if(!-e($cgifile)) {
   return "No such file $cgifile!";
 }
 
 my $OS=0;
 my $BinMode=0;
 my $CurOS=$^O;
 $CurOS="Win32" if($^O eq "MSWin32");
 $CurOS="Linux" if($^O eq "linux");
 $CurOS="FreeBSD" if($^O eq "freebsd"); 
 
 open(CF, "<$cgifile") || print "Error $cgifile $!";
  binmode(CF); 
    while( <CF> )    {
  	  if( !$OS && $_ =~ /$CurOS/ ) {
        $OS=1;
			}
  	  if( !$BinMode && ($_ =~ /\r\n/)  ) {
        $BinMode=1;
			}					
    }
 close(CF);
 
 if(!$OS) {
   $err="File $cgifile is compiled for other Operational System (Current OS: $^O)!"
 }
 if(!$BinMode) {
   $err="Error at uploading a file $cgifile (no binary mode)!"
 }
 
$err; 
}

sub errmsg {
  my($cmd, $rerr, $ret)=@_;
	my $emsg;
	if( $rerr ) {
    $emsg.="<br>Error: Run $cmd - $rerr!"  ;
	} else {
  	$errfile=&CheckErrorFile("$cmd");
	  $emsg.="<br>Error: $cmd $errfile" if( ($ret==256 || $ret==11 || $ret<0) && ($errfile ne ""));
	}	
	$!=$rerr;
$emsg;	
}

sub view_errors {

print qq~
</pre>
<center>
<h2> Errors</h2>
<br>
~;

 if( -e($ERROR_LOG) ) {
print qq~
 <table border=0 CELLPADDING=3 CELLSPACING=1 width=90% bgColor=gray>
 	<tr bgcolor=#ffffff>
	 <td><b>Time</td>
	 <td><b>Module</td>
	 <td><b>Action</td>
	 <td><b>Where</td>
	 <td><b>Details</td>	 
	 <td><b>Line</td>
	 <td><b>Fatal</td>	 	 	 	 
	</tr>	
~;
 
   open(FILE, "<$ERROR_LOG" ) || die("Can't read '$ERROR_LOG' $!");
     my @lines = <FILE>;
	   foreach $line ( @lines ) {
		  @ERR=split(/\|/, $line); 
 		  print "<tr bgcolor=#ffffff>";
			print "<td>".(scalar(localtime($ERR[0])))."</td>";
			print "<td>$ERR[5]</td>";
			print "<td>$ERR[2]</td>";
			print "<td>$ERR[4]</td>";
			print "<td>$ERR[3]</td>";			
			print "<td>$ERR[1]</td>";
			print "<td>$ERR[6]</td>";															
		  print "</tr>";			 
  	 }
    close(FILE);
		
print "</table>";
	
 } else {
   print "<h1> Errors not found</h1>" 
 }	

}